//
//  View.m
//  Pythagoras
//
//  Created by NYU User on 11/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "View.h"


@implementation View


- (id) initWithFrame: (CGRect) frame {
	if ((self = [super initWithFrame: frame]) != nil) {
		// Initialization code
		self.backgroundColor = [UIColor blueColor];
		theta = M_PI / 2;
	}
	return self;
}

- (void) touchesMoved: (NSSet *) touches withEvent: (UIEvent *) event {
	CGPoint location = [[touches anyObject] locationInView: self];
	CGPoint previous = [[touches anyObject] previousLocationInView: self];
	
	CGFloat dx = location.x - previous.x;
	theta -= dx / 50;
	
	//Keep theta in the range 0 to 180 degrees inclusive.
	
	if (theta < 0) {
		theta = 0;
	}
	
	if (theta > M_PI) {
		theta = M_PI;
	}
	
	[self setNeedsDisplay];	//trigger a call to darwRect:
}


// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void) drawRect: (CGRect) rect {
    // Drawing code
	CGRect b = self.bounds;
	CGFloat r = b.size.width / 4;
	
	const CGFloat theta2 = theta / 2;
	const CGFloat left = 2 * r * cosf(theta2);	//length of side of left little square
	const CGFloat right = 2 * r * sinf(theta2);	//length of side of right little square

	CGContextRef c = UIGraphicsGetCurrentContext();
	
	//origin in center of view
	CGContextTranslateCTM(c, b.size.width / 2, b.size.height / 2);
	
	//Y axis points up
	CGContextScaleCTM(c, 1, -1);
	
	CGContextBeginPath(c);

	CGRect square = CGRectMake(
		-r,
		-b.size.width / 2,
		b.size.width / 2,
		b.size.width / 2
	);
	
	CGContextAddRect(c, square);
	CGContextMoveToPoint(c, r, 0);
 
	
	CGContextAddArc(c,
		0, 0, //center of semicircle
		b.size.width / 4,	//radius
		0, M_PI,
		0		//counterclockwise
	);
	
	CGContextMoveToPoint(c, r, 0);
	
	//Three of the vertices of the right little square
	//(going counterclockwise):

	CGContextAddLineToPoint(c,
		r + right * cosf(theta2),
		right * sin(theta2)
	);
	
	CGContextAddLineToPoint(c,
		-r + (left + right) * cosf(theta2),
		(left + right) * sinf(theta2)
	);
		
	CGContextAddLineToPoint(c,
		-r + (left + right) * cosf(theta2),
		(left + right) * sinf(theta2)
	);
	
	//Three of the vertices of the left little square
	//(going clockwise):
	
	CGContextAddLineToPoint(c, -r, 0.0f);
	
	CGContextAddLineToPoint(c,
		-r - left * cosf(M_PI/2 - theta2),
		left * sinf(M_PI/2 - theta2)
	);
							
	CGContextAddLineToPoint(c,
		r - (left + right) * cos(M_PI/2 - theta2),
		(left + right) * sinf(M_PI/2 - theta2)
	);
	
	CGContextClosePath(c);
	CGContextSetRGBStrokeColor(c, 1.0, 1.0, 1.0, 1.0);
	CGContextStrokePath(c);
}


- (void) dealloc {
	[super dealloc];
}


@end
